Index: /java/main/src/main/java/com/framsticks/core/InstanceUtils.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/InstanceUtils.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/core/InstanceUtils.java	(revision 96)
@@ -0,0 +1,242 @@
+package com.framsticks.core;
+
+import java.util.List;
+
+import javax.annotation.Nonnull;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.communication.File;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ListAccess;
+import com.framsticks.params.Param;
+import com.framsticks.params.ValueParam;
+import com.framsticks.params.types.ObjectParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.parsers.Loaders;
+import com.framsticks.parsers.MultiParamLoader;
+import com.framsticks.util.AbstractStateFunctor;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.StateFunctor;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.RunAt;
+
+import static com.framsticks.util.dispatching.Dispatching.*;
+
+public final class InstanceUtils {
+
+	private static final Logger log = Logger.getLogger(InstanceUtils.class.getName());
+
+	private InstanceUtils() {
+	}
+
+	public static @Nonnull FramsClass processFetchedInfo(Instance instance, File file) {
+		assert instance.isActive();
+		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
+		if ("/".equals(file.getPath())) {
+			if (instance.getRoot().getParam().getContainedTypeName() == null) {
+				instance.setRoot(new Node(Param.build().name("Instance").id(instance.getName()).type("o " + framsClass.getId()).finish(CompositeParam.class), instance.getRoot().getObject()));
+			}
+		}
+		instance.putInfoIntoCache(framsClass);
+		return framsClass;
+	}
+
+	public static void findInfo(final Path path, final Future<FramsClass> future) {
+		Instance instance = path.getInstance();
+		assert instance.isActive();
+		final String name = path.getTop().getParam().getContainedTypeName();
+		final FramsClass framsClass = instance.getInfoFromCache(name);
+		if (framsClass != null) {
+			log.trace("info for " + name + " found in cache");
+			future.pass(framsClass);
+			return;
+		}
+		instance.fetchInfo(path, future);
+	}
+
+	public static void processFetchedValues(Path path, List<File> files) {
+		Instance instance = path.getInstance();
+		assert instance.isActive();
+		assert files.size() == 1;
+		assert path.isTheSame(files.get(0).getPath());
+		Node node = path.getTop();
+		MultiParamLoader loader = new MultiParamLoader();
+		loader.setNewSource(files.get(0).getContent());
+		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
+
+		try {
+			if (node.getParam() instanceof ObjectParam) {
+				loader.addAccessInterface(InstanceUtils.bindAccess(instance, node));
+				loader.go();
+				instance.notifyOfFetch(path);
+				return;
+			}
+
+			ListAccess listAccess = ((ListAccess) InstanceUtils.bindAccess(instance, node));
+			assert listAccess != null;
+			listAccess.clearValues();
+
+			AccessInterface elementAccess = listAccess.getElementAccess();
+			loader.addAccessInterface(elementAccess);
+			MultiParamLoader.Status status;
+			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
+				if (status == MultiParamLoader.Status.AfterObject) {
+					AccessInterface accessInterface = loader.getLastAccessInterface();
+
+					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
+					//TODO listAccessParam
+					Param param = Param.build().forAccess(accessInterface).id(id).finish();
+					Object child = accessInterface.getSelected();
+					accessInterface.select(null);
+					assert child != null;
+					InstanceUtils.bindAccess(instance, node).set((ValueParam) param, child);
+				}
+			}
+
+			instance.notifyOfFetch(path);
+		} catch (Exception e) {
+			log.error("exception occurred while loading: " + e);
+		}
+
+	}
+
+	public static void resolveAndFetch(final Instance instance, final String targetPath, final Future<Path> future) {
+		assert instance.isActive();
+		InstanceUtils.resolve(instance, targetPath, new Future<Path>(future) {
+			@Override
+			protected void result(final Path path) {
+				assert path.isResolved(targetPath);
+				//TODO Future
+				instance.fetchValues(path, new AbstractStateFunctor(future) {
+					@Override
+					public void call() {
+						future.pass(path);
+					}
+				});
+			}
+		});
+	}
+
+
+	public static void resolve(final Path path, final Future<Path> future) {
+		final Instance instance = path.getInstance();
+		assert instance.isActive();
+		if (path.getTop().getObject() != null) {
+			if (getInfoFromCache(path) != null) {
+				future.pass(path);
+				return;
+			}
+			InstanceUtils.findInfo(path, new Future<FramsClass>(future) {
+				@Override
+				protected void result(FramsClass result) {
+					future.pass(path);
+				}
+			});
+			return;
+		}
+		InstanceUtils.findInfo(path, new Future<FramsClass>(future) {
+			@Override
+			protected void result(FramsClass result) {
+				assert instance.isActive();
+				assert path.getTop().getParam().isMatchingContainedName(result.getId());
+				Path p = (path.getTop().getParam().getContainedTypeName() != null ? path : path.tryFindResolution());
+				future.pass(InstanceUtils.createIfNeeded(p));
+			}
+		});
+	}
+
+	public static Path createIfNeeded(Instance instance, String path) {
+		assert instance.isActive();
+		Path p;
+		while (!(p = Path.to(instance, path)).isResolved(path)) {
+			instance.create(p);
+		}
+		return p;
+	}
+
+	public static Path createIfNeeded(Path path) {
+		Instance instance = path.getInstance();
+		assert instance.isActive();
+		if (path.isResolved()) {
+			return path;
+		}
+		return instance.create(path);
+	}
+
+	public static @Nonnull AccessInterface bindAccess(Instance instance, String path) {
+		return bindAccess(Path.to(instance, path));
+	}
+
+	public static @Nonnull AccessInterface bindAccess(Instance instance, Node node) {
+		assert instance.isActive();
+		assert node.getObject() != null;
+
+		try {
+			AccessInterface access = instance.prepareAccess(node.getParam());
+			if (access == null) {
+				throw new FramsticksException().msg("failed to prepare access for param").arg("param", node.getParam());
+			}
+			return access.select(node.getObject());
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to prepare access for param").arg("param", node.getParam()).cause(e);
+			// log.error("failed to bind access for " + node.getParam() + ": " + e);
+		}
+	}
+
+	public static @Nonnull AccessInterface bindAccess(Path path) {
+		assert path.getInstance().isActive();
+		path.assureResolved();
+		return bindAccess(path.getInstance(), path.getTop());
+	}
+
+	public static void storeValue(final Path path, final ValueParam param, final Object value, final StateFunctor stateFunctor) {
+		final Instance instance = path.getInstance();
+
+		dispatchIfNotActive(instance, new RunAt<Instance>() {
+			@Override
+			public void run() {
+				instance.storeValue(path, param, value, stateFunctor);
+			}
+		});
+	}
+
+	public static void call(final Path path, final ProcedureParam param, final Object[] arguments, final Future<Object> future) {
+		final Instance instance = path.getInstance();
+
+		dispatchIfNotActive(instance, new RunAt<Instance>() {
+			@Override
+			public void run() {
+				instance.call(path, param, arguments, future);
+			}
+		});
+	}
+
+	/** This might not be correct. */
+	public static void resolve(final Instance instance, final String targetPath, final Future<Path> future) {
+		dispatchIfNotActive(instance, new RunAt<Instance>() {
+
+			@Override
+			public void run() {
+				instance.resolve(Path.to(instance, targetPath), new Future<Path>(future) {
+					@Override
+					protected void result(Path result) {
+						assert result.getInstance().isActive();
+						if (result.isResolved(targetPath)) {
+							future.pass(result);
+							return;
+						}
+						resolve(result.getInstance(), targetPath, future);
+					}
+				});
+			}
+		});
+	}
+
+	public static FramsClass getInfoFromCache(Path path) {
+		assert path.getInstance().isActive();
+		return path.getInstance().getInfoFromCache(path.getTop().getParam().getContainedTypeName());
+	}
+}
Index: /java/main/src/main/java/com/framsticks/core/ObjectInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/ObjectInstance.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/core/ObjectInstance.java	(revision 96)
@@ -5,13 +5,18 @@
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
 import com.framsticks.params.Param;
+import com.framsticks.params.ValueParam;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.UnsupportedOperationException;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.StateFunctor;
+import com.framsticks.util.dispatching.Future;
+// import static com.framsticks.core.InstanceUtils.*;
 
 @FramsClassAnnotation
-public class ObjectInstance extends Instance {
+public class ObjectInstance extends AbstractInstance {
 	private static final Logger log = Logger.getLogger(ObjectInstance.class);
 
@@ -20,5 +25,5 @@
 		registry.registerAndBuild(object.getClass());
 		AccessInterface access = registry.createAccess(object.getClass());
-		setRoot(Param.build().forAccess(access).id(getName()).finish(CompositeParam.class), object);
+		setRoot(new Node(Param.build().forAccess(access).id(getName()).finish(CompositeParam.class), object));
 	}
 
@@ -43,23 +48,66 @@
 		log.debug("requesting: " + path);
 		fireFetch(path);
-		stateFunctor.call(null);
+		stateFunctor.call();
 	}
 
 	@Override
-	public void fetchValue(Path path, Param param, StateFunctor stateFunctor) {
+	public void fetchValue(Path path, ValueParam param, StateFunctor stateFunctor) {
 		assert isActive();
 		fireFetch(path);
-		stateFunctor.call(null);
+		stateFunctor.call();
 	}
 
 	@Override
-	public void call(Path path, ProcedureParam param, Object[] arguments, StateFunctor stateFunctor) {
+	public void call(Path path, ProcedureParam param, Object[] arguments, Future<Object> future) {
 		assert isActive();
 		try {
-			bindAccess(path).call(param, arguments);
-			stateFunctor.call(null);
+			future.pass(InstanceUtils.bindAccess(path).call(param, arguments));
 		} catch (FramsticksException e) {
-			stateFunctor.call(e);
+			future.handle(e);
 		}
 	}
+
+	@Override
+	public void fetchInfo(Path path, Future<FramsClass> future) {
+		assert isActive();
+		Path p = path.tryResolveIfNeeded();
+		Class<?> javaClass = p.getTopObject().getClass();
+		FramsClass framsClass = registry.registerReflectedIfNeeded(javaClass);
+		if (framsClass != null) {
+			future.pass(framsClass);
+		} else {
+			future.handle(new FramsticksException().msg("failed to find info for class").arg("java class", javaClass));
+		}
+	}
+
+	@Override
+	public void resolve(Path path, Future<Path> future) {
+		assert isActive();
+		assert path.isOwner(this);
+		if (path.getTop().getObject() != null) {
+			future.pass(path);
+			return;
+		}
+		AccessInterface access = InstanceUtils.bindAccess(this, path.getUnder());
+		Object object = access.get(path.getTop().getParam(), Object.class);
+		if (object == null) {
+			future.pass(path);
+			return;
+		}
+		future.pass(path.appendResolution(object));
+	}
+
+	@Override
+	public void storeValue(Path path, ValueParam param, Object value, final StateFunctor stateFunctor) {
+		assert isActive();
+		stateFunctor.handle(new UnsupportedOperationException());
+	}
+
+	@Override
+	public Path create(Path path) {
+		assert isActive();
+		assert !path.isResolved();
+		throw new UnsupportedOperationException();
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Path.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/core/Path.java	(revision 96)
@@ -11,4 +11,5 @@
 import java.util.List;
 
+import javax.annotation.Nonnull;
 import javax.annotation.concurrent.Immutable;
 
@@ -32,5 +33,5 @@
 		}
 		try {
-			instance.registry.prepareAccess(param);
+			instance.prepareAccess(param);
 			return child;
 		} catch (FramsticksException e) {
@@ -119,5 +120,15 @@
 		}
 
-		public PathBuilder resolve(Instance instance, String textual) {
+		public static Iterator<String> splitPath(String path) {
+			List<String> list = new LinkedList<String>();
+			for (String s : path.split("/")) {
+				if (!s.isEmpty()) {
+					list.add(s);
+				}
+			}
+			return list.iterator();
+		}
+
+		public PathBuilder resolve(@Nonnull Instance instance, String textual) {
 
 			assert nodes.isEmpty();
@@ -129,7 +140,7 @@
 
 			StringBuilder b = new StringBuilder();
-			Iterator<String> i = Instance.splitPath(textual);
+			Iterator<String> i = splitPath(textual);
 			while (i.hasNext() && current.getObject() != null) {
-				AccessInterface access = instance.registry.prepareAccess(current.getParam());
+				AccessInterface access = instance.prepareAccess(current.getParam());
 				if (access == null) {
 					break;
@@ -205,9 +216,15 @@
 	}
 
-	public final Instance getInstance() {
+	public final @Nonnull Instance getInstance() {
 		assert Dispatching.isThreadSafe();
 		return instance;
 	}
 
+	public Path tryResolveIfNeeded() {
+		if (isResolved()) {
+			return this;
+		}
+		return tryFindResolution();
+	}
 
 	/** Attach resolution at end, if available.
@@ -221,5 +238,5 @@
 			return Path.build().resolve(instance, "/").finish();//appendResolution(instance.root.object);
 		}
-		Object child = getKnownChild(instance, instance.bindAccess(getUnder()), getTop().getParam());
+		Object child = getKnownChild(instance, InstanceUtils.bindAccess(instance, getUnder()), getTop().getParam());
 		if (child == null) {
 			return this;
@@ -266,4 +283,8 @@
 		}
 	}
+
+	public static Path to(@Nonnull Instance instance, String textual) {
+		return Path.build().resolve(instance, textual).finish();
+	}
 }
 
Index: /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java
===================================================================
--- /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 96)
@@ -1,4 +1,3 @@
 package com.framsticks.diagnostics;
-
 
 import java.util.Date;
@@ -14,8 +13,10 @@
 import com.framsticks.core.AbstractInstanceListener;
 import com.framsticks.core.Instance;
+import com.framsticks.core.Path;
 import com.framsticks.dumping.PrintWriterSink;
 import com.framsticks.dumping.SaveStream;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.remote.RecursiveFetcher;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Logging;
 import com.framsticks.util.PeriodicTask;
@@ -28,6 +29,5 @@
  */
 public class Diagnostics extends JoinableCollection<Instance> {
-	private static final Logger log =
-		Logger.getLogger(Diagnostics.class);
+	private static final Logger log = Logger.getLogger(Diagnostics.class);
 
 
@@ -59,19 +59,26 @@
 
 							log.info("starting periodic dump");
-							new RecursiveFetcher(instance, instance.getRootPath(), new StateFunctor() {
+							new RecursiveFetcher(instance, Path.to(instance, "/"), new StateFunctor() {
 								@Override
-								public void call(Exception e) {
-									if (Logging.log(log, "recursively fetch", instance, e)) {
-										again();
-										return;
-									}
+								public void handle(FramsticksException e) {
+									Logging.log(log, "recursively fetch", instance, e);
+									again();
+								}
+
+								@Override
+								public void call() {
 									log.info("instance resolved, saving");
 									try {
 										final String fileName = dumpsPath + "/" + instance + "_" + new SimpleDateFormat(dumpsFormat).format(new Date()) + ".param";
 										File file = new File(fileName);
-										new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), instance, instance.getRootPath(), new StateFunctor() {
+										new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), instance, Path.to(instance, "/"), new StateFunctor() {
 											@Override
-											public void call(Exception e) {
+											public void handle(FramsticksException e) {
 												Logging.log(log, "periodic dump in " + fileName + " of", instance, e);
+												again();
+											}
+
+											@Override
+											public void call() {
 												again();
 											}
Index: /java/main/src/main/java/com/framsticks/dumping/LoadStream.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 96)
@@ -2,4 +2,5 @@
 
 import com.framsticks.communication.File;
+import com.framsticks.core.InstanceUtils;
 import com.framsticks.core.Path;
 import com.framsticks.params.ListSource;
@@ -19,5 +20,5 @@
  * @author Piotr Sniegowski
  */
-public class LoadStream {
+public class LoadStream extends Stream {
 
 	private final static Logger log = Logger.getLogger(LoadStream.class.getName());
@@ -46,5 +47,5 @@
 			while ((line = stream.readLine()) != null) {
 				if (query == null) {
-					query = Strings.splitIntoPair(line, ' ', "\n");
+					query = Strings.splitIntoPair(line, ' ', "");
 					files = new LinkedList<File>();
 					log.trace("loading " + line);
@@ -58,9 +59,9 @@
 					if (line.equals("ok")) {
 						if (query.first.equals("get")) {
-							Path path = instance.createIfNeeded(query.second);
-							instance.processFetchedValues(path, files);
+							Path path = InstanceUtils.createIfNeeded(instance, query.second);
+							InstanceUtils.processFetchedValues(path, files);
 						} else if (query.first.equals("info")) {
 							assert files.size() == 1;
-							instance.processFetchedInfo(files.get(0));
+							InstanceUtils.processFetchedInfo(instance, files.get(0));
 						} else {
 							assert false;
@@ -82,9 +83,9 @@
 		} catch (IOException e) {
 			log.error("failed to load: " + e);
-			future.result(null, e);
+			future.handle(new FramsticksException().msg("failed to load stream").cause(e));
 			return;
 		}
 		log.info("loaded in: " + stopwatch);
-		future.result(instance.getPath(mountPath.getTextual()), null);
+		future.pass(Path.to(instance, mountPath.getTextual()));
 	}
 
Index: /java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 96)
@@ -1,4 +1,5 @@
 package com.framsticks.dumping;
 
+import static com.framsticks.core.InstanceUtils.*;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
@@ -22,5 +23,5 @@
  * @author Piotr Sniegowski
  */
-public class SaveStream {
+public class SaveStream extends Stream {
 
 	private final static Logger log = Logger.getLogger(SaveStream.class.getName());
@@ -55,5 +56,5 @@
 		assert instance.isActive();
 		log.info("stored in " + stopwatch);
-		stateFunctor.call(null);
+		stateFunctor.call();
 	}
 
@@ -63,5 +64,5 @@
 			log.debug("path " + path + " is not resolved - skipping");
 		} else {
-			AccessInterface access = instance.bindAccess(path);
+			AccessInterface access = bindAccess(path);
 			assert access != null;
 			FramsClass framsClass = access.getFramsClass();
@@ -85,5 +86,5 @@
 			for (CompositeParam p : filterInstanceof(access.getParams(), CompositeParam.class)) {
 				final Path childPath = path.appendNode(new Node(p, access.get(p, Object.class)));
-				if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
+				if (childPath.isResolved() && getInfoFromCache(childPath) != null) {
 					dispatchWrite(childPath);
 				}
Index: /java/main/src/main/java/com/framsticks/dumping/Stream.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/Stream.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/dumping/Stream.java	(revision 96)
@@ -0,0 +1,5 @@
+package com.framsticks.dumping;
+
+public class Stream {
+
+}
Index: /java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 96)
@@ -5,5 +5,4 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
-import com.framsticks.util.Logging;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
@@ -22,5 +21,4 @@
 import java.util.ArrayList;
 import java.util.List;
-import java.util.Map;
 import com.framsticks.util.dispatching.RunAt;
 
@@ -29,5 +27,5 @@
  */
 @FramsClassAnnotation
-public class Browser extends AbstractJoinable implements Dispatcher<Browser>, Entity, JoinableParent {
+public class Browser extends AbstractJoinable implements Dispatcher<Browser>, JoinableParent {
 
 	private static final Logger log = Logger.getLogger(Browser.class.getName());
@@ -72,19 +70,14 @@
 			@Override
 			public void run() {
-				i.resolveAndFetch(path, new Future<Path>() {
+				InstanceUtils.resolveAndFetch(i, path, new Future<Path>(future) {
 					@Override
-					public void result(final Path p, Exception e) {
-						Logging.log(log, "auto resolve path", path, e);
-						if (future != null) {
-							future.result(p, e);
-						}
-						if (e == null) {
-							mainFrame.dispatch(new RunAt<Frame>() {
-								@Override
-								public void run() {
-									mainFrame.goTo(p);
-								}
-							});
-						}
+					protected void result(final Path p) {
+						future.pass(p);
+						mainFrame.dispatch(new RunAt<Frame>() {
+							@Override
+							public void run() {
+								mainFrame.goTo(p);
+							}
+						});
 					}
 				});
@@ -132,5 +125,5 @@
 				@Override
 				public void run() {
-					final Path p = i.getRootPath();
+					final Path p = Path.to(i, "/");
 					dispatch(new RunAt<Browser>() {
 						@Override
@@ -194,6 +187,6 @@
 	 * @return the instances
 	 */
-	public Map<String, Instance> getInstances() {
-		return instances.getObservables();
+	public JoinableCollection<Instance> getInstances() {
+		return instances;
 	}
 
@@ -254,5 +247,4 @@
 	@Override
 	protected void joinableFinish() {
-		// TODO Auto-generated method stub
 
 	}
Index: /java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 96)
@@ -1,5 +1,4 @@
 package com.framsticks.gui;
 
-import com.framsticks.core.Entity;
 import com.framsticks.core.Instance;
 import com.framsticks.core.Path;
@@ -32,5 +31,5 @@
  */
 @SuppressWarnings("serial")
-public class Frame extends JoinableCollection<Instance> implements Entity, Dispatcher<Frame> {
+public class Frame extends JoinableCollection<Instance> implements Dispatcher<Frame> {
 
 	private static final Logger log = Logger.getLogger(Frame.class.getName());
@@ -82,5 +81,5 @@
 			public void windowClosing(WindowEvent e) {
 				log.info("received closing");
-				joinableFinish();
+				interrupt();
 			}
 		});
@@ -268,5 +267,5 @@
 		assert isActive();
 		Instance instance = path.getInstance();
-		assert browser.getInstances().containsValue(instance);
+		assert browser.getInstances().contains(instance);
 
 		InstanceAtFrame e = new InstanceAtFrame(instance, this);
Index: /java/main/src/main/java/com/framsticks/gui/TreeNode.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 96)
@@ -5,4 +5,5 @@
 import com.framsticks.communication.util.LoggingStateCallback;
 import com.framsticks.core.Instance;
+import com.framsticks.core.InstanceUtils;
 import com.framsticks.core.ListChange;
 import com.framsticks.core.Path;
@@ -15,8 +16,9 @@
 import com.framsticks.remote.*;
 import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Holder;
 import com.framsticks.util.swing.TooltipConstructor;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.AbstractStateFunctor;
 import com.framsticks.util.Logging;
-import com.framsticks.util.StateFunctor;
 import org.apache.log4j.Logger;
 import com.framsticks.util.dispatching.RunAt;
@@ -29,4 +31,5 @@
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 import com.framsticks.util.swing.TreeNodeUtils;
+import static com.framsticks.core.InstanceUtils.*;
 
 /**
@@ -73,8 +76,7 @@
 		assert p.getInstance().isActive();
 		log.debug("fetching: " + p);
-		p.getInstance().fetchValues(p, new StateFunctor() {
-			@Override
-			public void call(Exception e) {
-				//TODO removing should stay here
+		p.getInstance().fetchValues(p, new AbstractStateFunctor() {
+			@Override
+			public void call() {
 				// reactForFetchResult(p, e);
 			}
@@ -140,5 +142,5 @@
 		assert p.getInstance().isActive();
 		log.debug("updating children of " + this);
-		AccessInterface access = p.getInstance().bindAccess(p.getTop());
+		AccessInterface access = InstanceUtils.bindAccess(p.getInstance(), p.getTop());
 		if (access == null) {
 			return;
@@ -199,11 +201,7 @@
 					return;
 				}
-				p.getInstance().resolve(updated, new Future<Path>() {
+				p.getInstance().resolve(updated, new Future<Path>(Logging.logger(log, "resolve and select", TreeNode.this)) {
 					@Override
-					public void result(final Path result, Exception e) {
-						if (Logging.log(log, "resolve and select", TreeNode.this, e)) {
-							return;
-						}
-
+					protected void result(Path result) {
 						fetch(result);
 						postUpdatePath(result);
@@ -231,8 +229,5 @@
 			return;
 		}
-		AccessInterface access = p.getInstance().bindAccess(p);
-		if (access == null) {
-			return;
-		}
+		AccessInterface access = InstanceUtils.bindAccess(p);
 
 		final String tooltip = new TooltipConstructor()
@@ -309,5 +304,5 @@
 			@Override
 			public void run() {
-				AccessInterface access = p.getInstance().bindAccess(p);
+				AccessInterface access = InstanceUtils.bindAccess(p);
 				panel.pullValuesFromLocalToUser(access);
 
@@ -501,31 +496,27 @@
 			return;
 		}
-		final Map<ValueControl, Object> changes = localChanges;
+		Map<ValueControl, Object> changes = localChanges;
 		localChanges = null;
-		instanceAtFrame.getInstance().dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
-				for (Map.Entry<ValueControl, Object> e : changes.entrySet()) {
-					final ValueControl key = e.getKey();
-					final Path p = path;
-					instanceAtFrame.getInstance().storeValue(p, e.getKey().getParam(), e.getValue(), new StateFunctor() {
+		final Holder<Integer> counter = new Holder<>(changes.size());
+		final Path p = path;
+
+		for (Map.Entry<ValueControl, Object> e : localChanges.entrySet()) {
+			storeValue(p, e.getKey().getParam(), e.getValue(), new AbstractStateFunctor() {
+				@Override
+				public void call() {
+					counter.set(counter.get() - 1);
+					if (counter.get() != 0) {
+						return;
+					}
+					log.debug("applied changes for: " + p);
+					frame.dispatch(new RunAt<Frame>() {
 						@Override
-						public void call(Exception e) {
-							changes.remove(key);
-							if (!changes.isEmpty()) {
-								return;
-							}
-							log.debug("applied changes for: " + p);
-							frame.dispatch(new RunAt<Frame>() {
-								@Override
-								public void run() {
-									fillPanelWithValues();
-								}
-							});
+						public void run() {
+							fillPanelWithValues();
 						}
 					});
 				}
-			}
-		});
+			});
+		}
 	}
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 96)
@@ -8,6 +8,7 @@
 import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Logging;
-import com.framsticks.util.StateFunctor;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.RunAt;
 
@@ -67,8 +68,14 @@
 					@Override
 					public void run() {
-						path.getInstance().call(path, getParam(), arguments.toArray(), new StateFunctor() {
+						path.getInstance().call(path, getParam(), arguments.toArray(), new Future<Object>() {
+
 							@Override
-							public void call(Exception e) {
+							public void handle(FramsticksException e) {
 								Logging.log(log, "call procedure", path, e);
+							}
+
+							@Override
+							public void result(Object result) {
+
 							}
 						});
Index: /java/main/src/main/java/com/framsticks/gui/windows/console/ConsoleFrame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/windows/console/ConsoleFrame.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/gui/windows/console/ConsoleFrame.java	(revision 96)
@@ -161,5 +161,5 @@
 		}
 		String commandText = commandLine.getText();
-		Pair<String, String> command = Strings.splitIntoPair(commandText, ' ', "\n");
+		Pair<String, String> command = Strings.splitIntoPair(commandText, ' ', "");
 		Request request = Request.createRequestByTypeString(command.first);
 		if (request == null) {
